/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse tellparse
#define yylex   telllex
#define yyerror tellerror
#define yylval  telllval
#define yychar  tellchar
#define yydebug telldebug
#define yynerrs tellnerrs
#define yylloc telllloc

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     tknERROR = 258,
     tknIF = 259,
     tknELSE = 260,
     tknWHILE = 261,
     tknREPEAT = 262,
     tknUNTIL = 263,
     tknFOREACH = 264,
     tknSTRUCTdef = 265,
     tknVOIDdef = 266,
     tknREALdef = 267,
     tknBOOLdef = 268,
     tknINTdef = 269,
     tknSTRINGdef = 270,
     tknLAYOUTdef = 271,
     tknLISTdef = 272,
     tknRETURN = 273,
     tknTRUE = 274,
     tknFALSE = 275,
     tknLEQ = 276,
     tknGEQ = 277,
     tknEQ = 278,
     tknNEQ = 279,
     tknAND = 280,
     tknOR = 281,
     tknNOT = 282,
     tknBWAND = 283,
     tknBWOR = 284,
     tknBWNOT = 285,
     tknSW = 286,
     tknSE = 287,
     tknNE = 288,
     tknNW = 289,
     tknPREADD = 290,
     tknPRESUB = 291,
     tknPOSTADD = 292,
     tknPOSTSUB = 293,
     tknCONST = 294,
     tknIDENTIFIER = 295,
     tknFIELD = 296,
     tknSTRING = 297,
     tknREAL = 298,
     tknINT = 299
   };
#endif
/* Tokens.  */
#define tknERROR 258
#define tknIF 259
#define tknELSE 260
#define tknWHILE 261
#define tknREPEAT 262
#define tknUNTIL 263
#define tknFOREACH 264
#define tknSTRUCTdef 265
#define tknVOIDdef 266
#define tknREALdef 267
#define tknBOOLdef 268
#define tknINTdef 269
#define tknSTRINGdef 270
#define tknLAYOUTdef 271
#define tknLISTdef 272
#define tknRETURN 273
#define tknTRUE 274
#define tknFALSE 275
#define tknLEQ 276
#define tknGEQ 277
#define tknEQ 278
#define tknNEQ 279
#define tknAND 280
#define tknOR 281
#define tknNOT 282
#define tknBWAND 283
#define tknBWOR 284
#define tknBWNOT 285
#define tknSW 286
#define tknSE 287
#define tknNE 288
#define tknNW 289
#define tknPREADD 290
#define tknPRESUB 291
#define tknPOSTADD 292
#define tknPOSTSUB 293
#define tknCONST 294
#define tknIDENTIFIER 295
#define tknFIELD 296
#define tknSTRING 297
#define tknREAL 298
#define tknINT 299




/* Copy the first part of user declarations.  */
#line 40 "tell_yacc.yy"

#include "tpdph.h"
#include <sstream>
#include "tellyzer.h"
#include "ted_prompt.h"
#include "../tpd_common/outbox.h"
/* Switch on verbose error reporting messages*/
#define YYERROR_VERBOSE 1
/*Current command block - defined in tellyzer.cpp*/
extern parsercmd::cmdBLOCK*       CMDBlock;
/*Global console object*/
extern console::ted_cmd*           Console;
namespace parsercmd
{
   extern int EOfile();
}

/*Current tell variable name*/
telldata::tell_var *tellvar = NULL;
telldata::tell_var *tell_lvalue = NULL;
/*Current variable is a list*/
bool indexed = false;
bool lindexed = false;
/*Current commands - parsed, but not yet in the command stack*/
parsercmd::cmdFOREACH *foreach_command;
parsercmd::cmdLISTADD *listadd_command;
/*Current tell struct */
telldata::tell_type *tellstruct = NULL;
/* used for argument type checking during function call parse */
telldata::argumentQ   *argmap  = NULL;
/*taking care when a function is called from the argument list of another call*/
std::stack<telldata::argumentQ*>  argmapstack;

/* Current function declaration structure */
parsercmd::FuncDeclaration *cfd;
/*number of errors in a function defintion*/
int funcdeferrors = 0;
/*number of poits of the current polygon*/
unsigned listlength = 0;
void tellerror(std::string s, parsercmd::yyltype loc);
void tellerror (std::string s);



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
#line 221 "tell_yacc.yy"
{
   float                       real;
   bool                        ptypedef;
   int                         integer;
   char                       *parsestr;
    telldata::typeID           pttname;
   parsercmd::argumentLIST    *pfarguments;
    telldata::argumentQ       *plarguments;
    telldata::argumentID      *parguments;
   parsercmd::cmdBLOCK        *pblock;
   parsercmd::cmdFUNC         *pfblock;
   parsercmd::FuncDeclaration *pfdeclaration;
}
/* Line 187 of yacc.c.  */
#line 250 "tell_yacc.cc"
	YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 275 "tell_yacc.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
    YYLTYPE yyls;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  78
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   597

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  60
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  57
/* YYNRULES -- Number of rules.  */
#define YYNRULES  137
/* YYNRULES -- Number of states.  */
#define YYNSTATES  234

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   299

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      46,    47,    58,    56,    51,    57,     2,    59,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    45,
      54,    50,    55,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    52,     2,    53,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    48,     2,    49,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     8,    11,    13,    16,    18,    20,
      21,    28,    31,    32,    37,    38,    43,    45,    48,    54,
      62,    63,    64,    72,    74,    75,    76,    86,    87,    95,
      97,   101,   102,   104,   106,   108,   110,   112,   114,   116,
     118,   120,   122,   124,   125,   131,   135,   139,   140,   142,
     144,   146,   148,   150,   154,   155,   157,   159,   163,   166,
     168,   170,   172,   174,   176,   179,   183,   187,   190,   192,
     195,   197,   199,   201,   203,   205,   207,   209,   210,   217,
     219,   223,   226,   231,   237,   242,   248,   253,   259,   264,
     270,   275,   282,   288,   295,   301,   302,   307,   310,   312,
     316,   320,   322,   326,   330,   332,   336,   340,   342,   346,
     350,   354,   358,   360,   364,   368,   372,   376,   380,   384,
     386,   390,   394,   396,   399,   402,   405,   407,   409,   411,
     413,   415,   417,   419,   421,   423,   427,   429
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      61,     0,    -1,    62,    -1,    61,    62,    -1,    82,    45,
      -1,    65,    -1,    63,    45,    -1,     3,    -1,     1,    -1,
      -1,    96,    40,    46,    64,    89,    47,    -1,    63,    68,
      -1,    -1,    48,    67,    81,    49,    -1,    -1,    48,    69,
      81,    49,    -1,    18,    -1,    18,    87,    -1,     4,    46,
     109,    47,    66,    -1,     4,    46,   109,    47,    66,     5,
      66,    -1,    -1,    -1,     6,    46,    73,   109,    47,    74,
      66,    -1,   109,    -1,    -1,    -1,     9,    46,    77,    92,
      45,    75,    47,    78,    66,    -1,    -1,     7,    66,     8,
      46,    80,   109,    47,    -1,    82,    -1,    81,    45,    82,
      -1,    -1,    94,    -1,    85,    -1,    71,    -1,    72,    -1,
      76,    -1,    79,    -1,    70,    -1,    83,    -1,   104,    -1,
     105,    -1,    98,    -1,    -1,    40,    46,    84,    86,    47,
      -1,    92,    50,    87,    -1,   103,    50,    87,    -1,    -1,
      88,    -1,   109,    -1,    85,    -1,   106,    -1,    87,    -1,
      88,    51,    87,    -1,    -1,    90,    -1,    91,    -1,    90,
      51,    91,    -1,    96,    40,    -1,    93,    -1,    94,    -1,
      40,    -1,   101,    -1,   102,    -1,    96,    40,    -1,    39,
      96,    40,    -1,    94,    51,    40,    -1,    96,    40,    -1,
      97,    -1,    97,    17,    -1,    11,    -1,    12,    -1,    14,
      -1,    13,    -1,    15,    -1,    16,    -1,    40,    -1,    -1,
      10,    40,    99,    48,   100,    49,    -1,    95,    -1,   100,
      45,    95,    -1,    93,    41,    -1,    93,    52,   109,    53,
      -1,    93,    52,    35,   109,    53,    -1,    93,    52,    35,
      53,    -1,    93,    52,   109,    37,    53,    -1,    93,    52,
      37,    53,    -1,    93,    52,    36,   109,    53,    -1,    93,
      52,    36,    53,    -1,    93,    52,   109,    38,    53,    -1,
      93,    52,    38,    53,    -1,    93,    52,   109,    36,   109,
      53,    -1,    93,    52,   109,    36,    53,    -1,    93,    52,
     109,    38,   109,    53,    -1,    93,    52,    38,   109,    53,
      -1,    -1,    48,   107,    88,    49,    -1,    96,   106,    -1,
     110,    -1,   109,    26,   110,    -1,   109,    29,   110,    -1,
     111,    -1,   110,    25,   111,    -1,   110,    28,   111,    -1,
     112,    -1,   111,    23,   112,    -1,   111,    24,   112,    -1,
     113,    -1,   112,    54,   113,    -1,   112,    55,   113,    -1,
     112,    21,   113,    -1,   112,    22,   113,    -1,   114,    -1,
     113,    56,   114,    -1,   113,    57,   114,    -1,   113,    33,
     114,    -1,   113,    34,   114,    -1,   113,    32,   114,    -1,
     113,    31,   114,    -1,   115,    -1,   114,    58,   115,    -1,
     114,    59,   115,    -1,   116,    -1,    57,   116,    -1,    27,
     116,    -1,    30,   116,    -1,    43,    -1,    44,    -1,    19,
      -1,    20,    -1,    42,    -1,    93,    -1,   108,    -1,   104,
      -1,   105,    -1,    46,   109,    47,    -1,    83,    -1,     3,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   265,   265,   266,   270,   278,   279,   282,   286,   294,
     294,   305,   313,   313,   324,   324,   335,   347,   363,   368,
     375,   379,   375,   390,   401,   405,   401,   419,   419,   435,
     436,   440,   441,   442,   443,   444,   445,   446,   447,   448,
     449,   450,   451,   455,   455,   479,   485,   492,   493,   497,
     498,   499,   503,   504,   508,   509,   513,   514,   518,   526,
     527,   531,   542,   543,   547,   558,   569,   582,   595,   596,
     601,   602,   603,   604,   605,   606,   607,   621,   621,   639,
     640,   644,   658,   665,   675,   685,   695,   708,   713,   720,
     725,   735,   744,   753,   762,   774,   774,   798,   817,   818,
     819,   823,   824,   825,   829,   830,   831,   835,   836,   837,
     838,   839,   843,   844,   845,   846,   847,   848,   849,   853,
     854,   855,   859,   860,   861,   862,   866,   868,   870,   872,
     874,   877,   879,   881,   882,   883,   884,   885
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "tknERROR", "tknIF", "tknELSE",
  "tknWHILE", "tknREPEAT", "tknUNTIL", "tknFOREACH", "tknSTRUCTdef",
  "tknVOIDdef", "tknREALdef", "tknBOOLdef", "tknINTdef", "tknSTRINGdef",
  "tknLAYOUTdef", "tknLISTdef", "tknRETURN", "tknTRUE", "tknFALSE",
  "tknLEQ", "tknGEQ", "tknEQ", "tknNEQ", "tknAND", "tknOR", "tknNOT",
  "tknBWAND", "tknBWOR", "tknBWNOT", "tknSW", "tknSE", "tknNE", "tknNW",
  "tknPREADD", "tknPRESUB", "tknPOSTADD", "tknPOSTSUB", "tknCONST",
  "tknIDENTIFIER", "tknFIELD", "tknSTRING", "tknREAL", "tknINT", "';'",
  "'('", "')'", "'{'", "'}'", "'='", "','", "'['", "']'", "'<'", "'>'",
  "'+'", "'-'", "'*'", "'/'", "$accept", "input", "entrance",
  "funcdeclaration", "@1", "funcdefinition", "block", "@2", "funcblock",
  "@3", "returnstatement", "ifstatement", "whilestatement", "@4", "@5",
  "telllist", "foreachstatement", "@6", "@7", "repeatstatement", "@8",
  "statements", "statement", "funccall", "@9", "assignment", "arguments",
  "argument", "nearguments", "funcarguments", "funcneargument",
  "funcargument", "lvalue", "variable", "variabledeclaration",
  "fielddeclaration", "telltypeID", "telltype", "recorddefinition", "@10",
  "typedefstruct", "fieldname", "listindex", "listinsert", "listremove",
  "listslice", "structure", "@11", "anonymousvar", "expression",
  "andexpression", "eqexpression", "relexpression", "addexpression",
  "multiexpression", "unaryexpression", "primaryexpression", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,    59,    40,    41,   123,   125,
      61,    44,    91,    93,    60,    62,    43,    45,    42,    47
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    60,    61,    61,    62,    62,    62,    62,    62,    64,
      63,    65,    67,    66,    69,    68,    70,    70,    71,    71,
      73,    74,    72,    75,    77,    78,    76,    80,    79,    81,
      81,    82,    82,    82,    82,    82,    82,    82,    82,    82,
      82,    82,    82,    84,    83,    85,    85,    86,    86,    87,
      87,    87,    88,    88,    89,    89,    90,    90,    91,    92,
      92,    93,    93,    93,    94,    94,    94,    95,    96,    96,
      97,    97,    97,    97,    97,    97,    97,    99,    98,   100,
     100,   101,   102,   103,   103,   103,   103,   104,   104,   104,
     104,   105,   105,   105,   105,   107,   106,   108,   109,   109,
     109,   110,   110,   110,   111,   111,   111,   112,   112,   112,
     112,   112,   113,   113,   113,   113,   113,   113,   113,   114,
     114,   114,   115,   115,   115,   115,   116,   116,   116,   116,
     116,   116,   116,   116,   116,   116,   116,   116
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     2,     2,     1,     2,     1,     1,     0,
       6,     2,     0,     4,     0,     4,     1,     2,     5,     7,
       0,     0,     7,     1,     0,     0,     9,     0,     7,     1,
       3,     0,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     0,     5,     3,     3,     0,     1,     1,
       1,     1,     1,     3,     0,     1,     1,     3,     2,     1,
       1,     1,     1,     1,     2,     3,     3,     2,     1,     2,
       1,     1,     1,     1,     1,     1,     1,     0,     6,     1,
       3,     2,     4,     5,     4,     5,     4,     5,     4,     5,
       4,     6,     5,     6,     5,     0,     4,     2,     1,     3,
       3,     1,     3,     3,     1,     3,     3,     1,     3,     3,
       3,     3,     1,     3,     3,     3,     3,     3,     3,     1,
       3,     3,     1,     2,     2,     2,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,     8,     7,     0,     0,     0,     0,     0,    70,    71,
      73,    72,    74,    75,    16,     0,    61,     0,     2,     0,
       5,    38,    34,    35,    36,    37,     0,    39,    33,     0,
      59,    32,     0,    68,    42,    62,    63,     0,    40,    41,
       0,    20,    12,     0,    24,    77,   137,   128,   129,     0,
       0,   130,   126,   127,     0,    95,     0,   136,    50,    17,
     131,    60,     0,   133,   134,    51,   132,    49,    98,   101,
     104,   107,   112,   119,   122,    76,     0,    43,     1,     3,
       6,    14,    11,     4,     0,    81,     0,     0,    64,    69,
       0,   131,     0,     0,     0,    31,     0,     0,     0,   124,
     125,     0,     0,   123,    64,    97,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    65,    47,    31,    45,     0,     0,
       0,     0,     0,    66,     9,    46,     0,     0,     0,     0,
      29,     0,    27,    61,     0,    59,     0,   135,    52,     0,
      99,   100,   102,   103,   105,   106,   110,   111,   108,   109,
     118,   117,   115,   116,   113,   114,   120,   121,     0,    48,
       0,    84,     0,    88,     0,    86,    90,     0,     0,     0,
       0,    82,    54,     0,    18,    21,    31,    13,     0,     0,
       0,    79,     0,     0,    96,     0,    44,    15,    83,    87,
      94,    92,     0,    85,    89,     0,     0,    55,    56,     0,
       0,     0,    30,     0,     0,    23,     0,    67,     0,    78,
      53,    91,    93,    10,     0,    58,    19,    22,    28,    25,
      80,    57,     0,    26
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    17,    18,    19,   182,    20,    43,    95,    82,   126,
      21,    22,    23,    94,   211,   214,    24,    97,   232,    25,
     188,   139,    26,    57,   125,    58,   168,   148,   149,   206,
     207,   208,    29,    91,    61,   191,    92,    33,    34,    98,
     193,    35,    36,    37,    63,    64,    65,   102,    66,    67,
      68,    69,    70,    71,    72,    73,    74
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -137
static const yytype_int16 yypact[] =
{
     148,  -137,  -137,   -20,    27,    33,    43,    51,  -137,  -137,
    -137,  -137,  -137,  -137,   236,   161,    -4,    47,  -137,   152,
    -137,  -137,  -137,  -137,  -137,  -137,    88,  -137,  -137,    93,
      87,    73,   110,   208,  -137,  -137,  -137,   128,  -137,  -137,
     499,  -137,  -137,   209,  -137,  -137,  -137,  -137,  -137,   535,
     535,  -137,  -137,  -137,   499,  -137,   535,  -137,  -137,  -137,
      30,   178,   -29,  -137,  -137,  -137,  -137,   197,   234,    86,
      13,   175,   126,  -137,  -137,  -137,   201,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,   236,  -137,   200,   205,   214,  -137,
     236,    96,   219,    -6,   499,   553,   231,   101,   233,  -137,
    -137,   106,   236,  -137,  -137,  -137,   499,   499,   499,   499,
     499,   499,   499,   499,   499,   499,   499,   499,   499,   499,
     499,   499,   499,   499,  -137,   236,   553,  -137,   319,   355,
     230,   391,   232,  -137,  -137,  -137,   283,    33,   118,   -21,
    -137,   260,  -137,    15,   256,   115,   161,  -137,  -137,   119,
     234,   234,    86,    86,    13,    13,   175,   175,   175,   175,
     126,   126,   126,   126,   126,   126,  -137,  -137,   257,   254,
      34,  -137,   -23,  -137,    11,  -137,  -137,    17,   427,   253,
     463,  -137,   161,   544,   302,  -137,   553,  -137,   499,   499,
     499,  -137,   268,    59,  -137,   236,  -137,  -137,  -137,  -137,
    -137,  -137,    23,  -137,  -137,    40,   262,   261,  -137,   271,
      33,    33,  -137,   163,   267,   197,    92,  -137,   161,  -137,
    -137,  -137,  -137,  -137,   161,  -137,  -137,  -137,  -137,  -137,
    -137,  -137,    33,  -137
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -137,  -137,   298,  -137,  -137,  -137,  -136,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,  -137,
    -137,   190,   -88,     5,  -137,     8,  -137,   -12,   192,  -137,
    -137,    94,   223,     4,    10,   123,     0,  -137,  -137,  -137,
    -137,  -137,  -137,  -137,    12,    16,   -53,  -137,  -137,    -9,
      98,   125,   143,   159,   171,   142,   172
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -77
static const yytype_int16 yytable[] =
{
      32,   184,    59,   106,    30,    27,   107,   140,    28,   105,
      31,   104,    38,   -76,    62,    76,    39,    32,    60,    55,
     106,    30,    27,   107,   186,    28,    40,    31,   187,    38,
     198,    93,   -76,    39,   112,   113,   -76,   106,   140,   105,
     107,   137,    77,   106,   -76,   101,   107,    78,     1,   106,
       2,     3,   107,     4,     5,   -76,     6,     7,     8,     9,
      10,    11,    12,    13,   199,    14,   106,   114,   115,   107,
     200,    85,   127,    41,   226,   227,   221,   132,   135,   186,
     -59,    42,    86,   197,    62,   138,    15,    16,    60,    44,
      62,    45,   -31,   222,    60,   141,   233,   141,   212,    30,
      27,   145,    62,    28,   218,    31,    60,    38,   219,   110,
     111,    39,     8,     9,    10,    11,    12,    13,   106,   172,
     174,   107,   177,   -60,    87,    62,   141,   183,    85,    60,
      30,    27,   106,    83,    28,   107,    31,    85,    38,    86,
      15,   143,    39,    84,   106,   181,   192,   107,   136,     1,
      88,     2,     3,   147,     4,     5,    85,     6,     7,     8,
       9,    10,    11,    12,    13,   185,    14,   190,   194,   202,
     195,   205,     8,     9,    10,    11,    12,    13,    90,   213,
     215,   216,   209,   220,   122,   123,   141,    15,    16,   106,
      30,    27,   107,   -31,    28,    62,    31,    80,    38,    60,
      81,    75,    39,    46,   150,   151,   116,   117,   118,   119,
     228,     8,     9,    10,    11,    12,    13,    96,   192,    47,
      48,    99,   100,   106,   209,    89,   107,    49,   103,    87,
      50,   120,   121,   152,   153,   128,   129,   130,   131,    46,
      16,   124,    51,    52,    53,   133,    54,     8,     9,    10,
      11,    12,    13,   154,   155,    47,    48,    56,   106,   108,
     134,   107,   109,    49,   166,   167,    50,    55,   178,   179,
     180,   156,   157,   158,   159,    15,    16,   142,    51,    52,
      53,   146,    54,   175,    55,   181,    46,   160,   161,   162,
     163,   164,   165,    56,     8,     9,    10,    11,    12,    13,
     104,   189,    47,    48,   196,   195,   203,   210,   217,   223,
      49,   225,   224,    50,   229,    79,   170,   169,   231,   129,
     144,   131,    46,    16,     0,    51,    52,    53,     0,    54,
       8,     9,    10,    11,    12,    13,     0,     0,    47,    48,
      56,   230,     0,     0,     0,     0,    49,     0,     0,    50,
       0,     0,     0,     0,     0,     0,     0,     0,    46,    16,
       0,    51,    52,    53,     0,    54,     8,     9,    10,    11,
      12,    13,   171,     0,    47,    48,    56,     0,     0,     0,
       0,     0,    49,     0,     0,    50,     0,     0,     0,     0,
       0,     0,     0,     0,    46,    16,     0,    51,    52,    53,
       0,    54,     8,     9,    10,    11,    12,    13,   173,     0,
      47,    48,    56,     0,     0,     0,     0,     0,    49,     0,
       0,    50,     0,     0,     0,     0,     0,     0,     0,     0,
      46,    16,     0,    51,    52,    53,     0,    54,     8,     9,
      10,    11,    12,    13,   176,     0,    47,    48,    56,     0,
       0,     0,     0,     0,    49,     0,     0,    50,     0,     0,
       0,     0,     0,     0,     0,     0,    46,    16,     0,    51,
      52,    53,     0,    54,     8,     9,    10,    11,    12,    13,
     201,     0,    47,    48,    56,     0,     0,     0,     0,     0,
      49,     0,     0,    50,     0,     0,     0,     0,     0,     0,
       0,     0,    46,    16,     0,    51,    52,    53,     0,    54,
       8,     9,    10,    11,    12,    13,   204,     0,    47,    48,
      56,     0,     0,     0,     0,     0,    49,     0,     0,    50,
       0,     0,     0,     0,     0,     0,     0,     0,    46,    16,
       0,    51,    52,    53,     0,    54,     8,     9,    10,    11,
      12,    13,     0,     0,    47,    48,    56,     3,     0,     4,
       5,     0,     6,     7,     8,     9,    10,    11,    12,    13,
     106,    14,     0,   107,     0,    16,     0,    51,    52,    53,
     178,    54,   180,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    15,    16,     0,     0,     0,   181
};

static const yytype_int16 yycheck[] =
{
       0,   137,    14,    26,     0,     0,    29,    95,     0,    62,
       0,    40,     0,    17,    14,    15,     0,    17,    14,    48,
      26,    17,    17,    29,    45,    17,    46,    17,    49,    17,
      53,    40,    17,    17,    21,    22,    40,    26,   126,    92,
      29,    47,    46,    26,    48,    54,    29,     0,     1,    26,
       3,     4,    29,     6,     7,    40,     9,    10,    11,    12,
      13,    14,    15,    16,    53,    18,    26,    54,    55,    29,
      53,    41,    84,    46,   210,   211,    53,    86,    90,    45,
      50,    48,    52,    49,    84,    94,    39,    40,    84,    46,
      90,    40,    45,    53,    90,    95,   232,    97,   186,    95,
      95,    97,   102,    95,    45,    95,   102,    95,    49,    23,
      24,    95,    11,    12,    13,    14,    15,    16,    26,   128,
     129,    29,   131,    50,    51,   125,   126,   136,    41,   125,
     126,   126,    26,    45,   126,    29,   126,    41,   126,    52,
      39,    40,   126,    50,    26,    53,   146,    29,    52,     1,
      40,     3,     4,    47,     6,     7,    41,     9,    10,    11,
      12,    13,    14,    15,    16,    47,    18,    52,    49,   178,
      51,   180,    11,    12,    13,    14,    15,    16,    50,   188,
     189,   190,   182,   195,    58,    59,   186,    39,    40,    26,
     186,   186,    29,    45,   186,   195,   186,    45,   186,   195,
      48,    40,   186,     3,   106,   107,    31,    32,    33,    34,
      47,    11,    12,    13,    14,    15,    16,     8,   218,    19,
      20,    49,    50,    26,   224,    17,    29,    27,    56,    51,
      30,    56,    57,   108,   109,    35,    36,    37,    38,     3,
      40,    40,    42,    43,    44,    40,    46,    11,    12,    13,
      14,    15,    16,   110,   111,    19,    20,    57,    26,    25,
      46,    29,    28,    27,   122,   123,    30,    48,    36,    37,
      38,   112,   113,   114,   115,    39,    40,    46,    42,    43,
      44,    48,    46,    53,    48,    53,     3,   116,   117,   118,
     119,   120,   121,    57,    11,    12,    13,    14,    15,    16,
      40,    45,    19,    20,    47,    51,    53,     5,    40,    47,
      27,    40,    51,    30,    47,    17,   126,   125,   224,    36,
      97,    38,     3,    40,    -1,    42,    43,    44,    -1,    46,
      11,    12,    13,    14,    15,    16,    -1,    -1,    19,    20,
      57,   218,    -1,    -1,    -1,    -1,    27,    -1,    -1,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    40,
      -1,    42,    43,    44,    -1,    46,    11,    12,    13,    14,
      15,    16,    53,    -1,    19,    20,    57,    -1,    -1,    -1,
      -1,    -1,    27,    -1,    -1,    30,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,     3,    40,    -1,    42,    43,    44,
      -1,    46,    11,    12,    13,    14,    15,    16,    53,    -1,
      19,    20,    57,    -1,    -1,    -1,    -1,    -1,    27,    -1,
      -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    40,    -1,    42,    43,    44,    -1,    46,    11,    12,
      13,    14,    15,    16,    53,    -1,    19,    20,    57,    -1,
      -1,    -1,    -1,    -1,    27,    -1,    -1,    30,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    40,    -1,    42,
      43,    44,    -1,    46,    11,    12,    13,    14,    15,    16,
      53,    -1,    19,    20,    57,    -1,    -1,    -1,    -1,    -1,
      27,    -1,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,     3,    40,    -1,    42,    43,    44,    -1,    46,
      11,    12,    13,    14,    15,    16,    53,    -1,    19,    20,
      57,    -1,    -1,    -1,    -1,    -1,    27,    -1,    -1,    30,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,     3,    40,
      -1,    42,    43,    44,    -1,    46,    11,    12,    13,    14,
      15,    16,    -1,    -1,    19,    20,    57,     4,    -1,     6,
       7,    -1,     9,    10,    11,    12,    13,    14,    15,    16,
      26,    18,    -1,    29,    -1,    40,    -1,    42,    43,    44,
      36,    46,    38,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    39,    40,    -1,    -1,    -1,    53
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     1,     3,     4,     6,     7,     9,    10,    11,    12,
      13,    14,    15,    16,    18,    39,    40,    61,    62,    63,
      65,    70,    71,    72,    76,    79,    82,    83,    85,    92,
      93,    94,    96,    97,    98,   101,   102,   103,   104,   105,
      46,    46,    48,    66,    46,    40,     3,    19,    20,    27,
      30,    42,    43,    44,    46,    48,    57,    83,    85,    87,
      93,    94,    96,   104,   105,   106,   108,   109,   110,   111,
     112,   113,   114,   115,   116,    40,    96,    46,     0,    62,
      45,    48,    68,    45,    50,    41,    52,    51,    40,    17,
      50,    93,    96,   109,    73,    67,     8,    77,    99,   116,
     116,   109,   107,   116,    40,   106,    26,    29,    25,    28,
      23,    24,    21,    22,    54,    55,    31,    32,    33,    34,
      56,    57,    58,    59,    40,    84,    69,    87,    35,    36,
      37,    38,   109,    40,    46,    87,    52,    47,   109,    81,
      82,    96,    46,    40,    92,    93,    48,    47,    87,    88,
     110,   110,   111,   111,   112,   112,   113,   113,   113,   113,
     114,   114,   114,   114,   114,   114,   115,   115,    86,    88,
      81,    53,   109,    53,   109,    53,    53,   109,    36,    37,
      38,    53,    64,   109,    66,    47,    45,    49,    80,    45,
      52,    95,    96,   100,    49,    51,    47,    49,    53,    53,
      53,    53,   109,    53,    53,   109,    89,    90,    91,    96,
       5,    74,    82,   109,    75,   109,   109,    40,    45,    49,
      87,    53,    53,    47,    51,    40,    66,    66,    47,    47,
      95,    91,    78,    66
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;
/* Location data for the look-ahead symbol.  */
YYLTYPE yylloc;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;

  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[2];

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;
#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 0;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
	YYSTACK_RELOCATE (yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 265 "tell_yacc.yy"
    {}
    break;

  case 3:
#line 266 "tell_yacc.yy"
    {}
    break;

  case 4:
#line 270 "tell_yacc.yy"
    {
      if (!yynerrs)  CMDBlock->execute();
      else 
      {           
         CMDBlock = CMDBlock->cleaner();
         parsercmd::EOfile();
      }
   }
    break;

  case 5:
#line 278 "tell_yacc.yy"
    {}
    break;

  case 6:
#line 279 "tell_yacc.yy"
    {
      delete((yyvsp[(1) - (2)].pfdeclaration)); cfd = NULL;
   }
    break;

  case 7:
#line 282 "tell_yacc.yy"
    {
      tellerror("Unexpected symbol", (yylsp[(1) - (1)]));
      parsercmd::EOfile();
   }
    break;

  case 8:
#line 286 "tell_yacc.yy"
    {
      CMDBlock = CMDBlock->cleaner();
      parsercmd::EOfile();
      /*yynerrs = 0;*/
   }
    break;

  case 9:
#line 294 "tell_yacc.yy"
    {
      cfd = DEBUG_NEW parsercmd::FuncDeclaration((yyvsp[(2) - (3)].parsestr), (yyvsp[(1) - (3)].pttname)) ;
   }
    break;

  case 10:
#line 297 "tell_yacc.yy"
    {
      CMDBlock->addUSERFUNCDECL(cfd,(yyloc));
      (yyval.pfdeclaration) = cfd;
      delete [] (yyvsp[(2) - (6)].parsestr);
   }
    break;

  case 11:
#line 305 "tell_yacc.yy"
    {
      CMDBlock->addUSERFUNC((yyvsp[(1) - (2)].pfdeclaration), (yyvsp[(2) - (2)].pfblock), (yyloc));
      // addUSERFUNC will take care about cleaning the funcdeclaration ($1) and funcblock ($2) 
      cfd = NULL;
   }
    break;

  case 12:
#line 313 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 13:
#line 317 "tell_yacc.yy"
    {
         (yyval.pblock) = CMDBlock;
         CMDBlock = CMDBlock->popblk();
      }
    break;

  case 14:
#line 324 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdFUNC(cfd->argListCopy(),cfd->type(),false);
         CMDBlock->pushblk();
      }
    break;

  case 15:
#line 328 "tell_yacc.yy"
    {
         (yyval.pfblock) = static_cast<parsercmd::cmdFUNC*>(CMDBlock);
         CMDBlock = CMDBlock->popblk();
      }
    break;

  case 16:
#line 335 "tell_yacc.yy"
    {
      if (!cfd) tellerror("return statement outside function body", (yylsp[(1) - (1)]));
      else {
         parsercmd::cmdRETURN* rcmd = DEBUG_NEW parsercmd::cmdRETURN(cfd->type());
         if (rcmd->checkRetype(NULL)) CMDBlock->pushcmd(rcmd);
         else {
            tellerror("return value expected", (yylsp[(1) - (1)]));
            delete rcmd;
         }
      }
      cfd->incReturns();
   }
    break;

  case 17:
#line 347 "tell_yacc.yy"
    {
      if (!cfd) tellerror("return statement outside function body", (yylsp[(1) - (2)]));
      else {
         parsercmd::cmdRETURN* rcmd = DEBUG_NEW parsercmd::cmdRETURN(cfd->type());
         if (rcmd->checkRetype((yyvsp[(2) - (2)].parguments))) CMDBlock->pushcmd(rcmd);
         else {
            tellerror("return type different from function type", (yylsp[(2) - (2)]));
            delete rcmd;
         }
         delete (yyvsp[(2) - (2)].parguments);
      }
      cfd->incReturns();
   }
    break;

  case 18:
#line 363 "tell_yacc.yy"
    {
         if (telldata::tn_bool != (yyvsp[(3) - (5)].pttname)) tellerror("bool type expected",(yylsp[(3) - (5)]));
         else CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdIFELSE((yyvsp[(5) - (5)].pblock), NULL));
      }
    break;

  case 19:
#line 368 "tell_yacc.yy"
    {
         if (telldata::tn_bool != (yyvsp[(3) - (7)].pttname)) tellerror("bool type expected",(yylsp[(3) - (7)]));
         else CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdIFELSE((yyvsp[(5) - (7)].pblock),(yyvsp[(7) - (7)].pblock)));
      }
    break;

  case 20:
#line 375 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 21:
#line 379 "tell_yacc.yy"
    {
         if (telldata::tn_bool != (yyvsp[(4) - (5)].pttname)) tellerror("bool type expected", (yylsp[(4) - (5)]));
      }
    break;

  case 22:
#line 382 "tell_yacc.yy"
    {
         parsercmd::cmdBLOCK* condBlock = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdWHILE(condBlock,(yyvsp[(7) - (7)].pblock)));
      }
    break;

  case 23:
#line 390 "tell_yacc.yy"
    {
         if       (!((yyvsp[(1) - (1)].pttname) & telldata::tn_listmask)) {
            tellerror("list expected",(yylsp[(1) - (1)]));
            (yyval.pttname) = telldata::tn_NULL;
         }
         else
            (yyval.pttname) = (yyvsp[(1) - (1)].pttname);
      }
    break;

  case 24:
#line 401 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 25:
#line 405 "tell_yacc.yy"
    {
         if  (((yyvsp[(4) - (7)].pttname) | telldata::tn_listmask) != (yyvsp[(6) - (7)].pttname))
            tellerror("unappropriate variable type",(yylsp[(4) - (7)]));
         foreach_command = DEBUG_NEW parsercmd::cmdFOREACH(tell_lvalue,tellvar);
      }
    break;

  case 26:
#line 410 "tell_yacc.yy"
    {
         parsercmd::cmdBLOCK* foreach_block = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         foreach_command->addBlocks(foreach_block,(yyvsp[(9) - (9)].pblock));
         CMDBlock->pushcmd(foreach_command);
      }
    break;

  case 27:
#line 419 "tell_yacc.yy"
    {
         CMDBlock = DEBUG_NEW parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 28:
#line 423 "tell_yacc.yy"
    {
         parsercmd::cmdBLOCK* condBlock = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         if (telldata::tn_bool != (yyvsp[(6) - (7)].pttname)) {
            tellerror("bool type expected", (yylsp[(6) - (7)]));
            delete condBlock;
         }
         else CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdREPEAT(condBlock,(yyvsp[(2) - (7)].pblock)));
   }
    break;

  case 29:
#line 435 "tell_yacc.yy"
    {}
    break;

  case 30:
#line 436 "tell_yacc.yy"
    {}
    break;

  case 31:
#line 440 "tell_yacc.yy"
    { }
    break;

  case 32:
#line 441 "tell_yacc.yy"
    { }
    break;

  case 33:
#line 442 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 34:
#line 443 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 35:
#line 444 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 36:
#line 445 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 37:
#line 446 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 38:
#line 447 "tell_yacc.yy"
    {/*keep the return value in the stack*/}
    break;

  case 39:
#line 448 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 40:
#line 449 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 41:
#line 450 "tell_yacc.yy"
    {CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdSTACKRST());}
    break;

  case 42:
#line 451 "tell_yacc.yy"
    { }
    break;

  case 43:
#line 455 "tell_yacc.yy"
    {
        argmap = DEBUG_NEW telldata::argumentQ;
        argmapstack.push(argmap);
   }
    break;

  case 44:
#line 459 "tell_yacc.yy"
    {
      parsercmd::cmdSTDFUNC *fc = CMDBlock->getFuncBody((yyvsp[(1) - (5)].parsestr),(yyvsp[(4) - (5)].plarguments));
      if (fc) {
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdFUNCCALL(fc,(yyvsp[(1) - (5)].parsestr)));
         (yyval.pttname) = fc->gettype();
      }
      else {
         tellerror("unknown function name or wrong parameter list",(yylsp[(1) - (5)]));
         (yyval.pttname) = telldata::tn_NULL;
      }
      telldata::argQClear(argmap);
      argmapstack.pop();
      delete argmap;
      if (argmapstack.size() > 0) argmap = argmapstack.top();
      else argmap = NULL;
      delete [] (yyvsp[(1) - (5)].parsestr);
   }
    break;

  case 45:
#line 479 "tell_yacc.yy"
    {
      /*because of the (possible) structure that has an unknown yet tn_usertypes type,
      here we are doing the type checking, using the type of the lvalue*/
      (yyval.pttname) = parsercmd::Assign(tell_lvalue, lindexed, (yyvsp[(3) - (3)].parguments), (yylsp[(2) - (3)]));
      delete (yyvsp[(3) - (3)].parguments);
   }
    break;

  case 46:
#line 485 "tell_yacc.yy"
    {
      (yyval.pttname) = parsercmd::Uninsert(tell_lvalue, (yyvsp[(3) - (3)].parguments), listadd_command, (yylsp[(2) - (3)]));
      delete (yyvsp[(3) - (3)].parguments);
   }
    break;

  case 47:
#line 492 "tell_yacc.yy"
    {(yyval.plarguments) = NULL;}
    break;

  case 48:
#line 493 "tell_yacc.yy"
    {(yyval.plarguments) = (yyvsp[(1) - (1)].plarguments);}
    break;

  case 49:
#line 497 "tell_yacc.yy"
    {(yyval.parguments) = DEBUG_NEW telldata::argumentID((yyvsp[(1) - (1)].pttname));}
    break;

  case 50:
#line 498 "tell_yacc.yy"
    {(yyval.parguments) = DEBUG_NEW telldata::argumentID((yyvsp[(1) - (1)].pttname));}
    break;

  case 51:
#line 499 "tell_yacc.yy"
    {(yyval.parguments) = (yyvsp[(1) - (1)].parguments);}
    break;

  case 52:
#line 503 "tell_yacc.yy"
    {argmap->push_back((yyvsp[(1) - (1)].parguments)); (yyval.plarguments) = argmap;}
    break;

  case 53:
#line 504 "tell_yacc.yy"
    {argmap->push_back((yyvsp[(3) - (3)].parguments)); (yyval.plarguments) = argmap;}
    break;

  case 54:
#line 508 "tell_yacc.yy"
    {}
    break;

  case 55:
#line 509 "tell_yacc.yy"
    {}
    break;

  case 56:
#line 513 "tell_yacc.yy"
    {}
    break;

  case 57:
#line 514 "tell_yacc.yy"
    {}
    break;

  case 58:
#line 518 "tell_yacc.yy"
    {
      tellvar = CMDBlock->newTellvar((yyvsp[(1) - (2)].pttname), (yylsp[(1) - (2)]));
      cfd->pushArg(DEBUG_NEW parsercmd::argumentTYPE((yyvsp[(2) - (2)].parsestr),tellvar));
      delete [] (yyvsp[(2) - (2)].parsestr);
   }
    break;

  case 59:
#line 526 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);tell_lvalue = tellvar; lindexed = indexed;}
    break;

  case 60:
#line 527 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);tell_lvalue = tellvar; lindexed = indexed;}
    break;

  case 61:
#line 531 "tell_yacc.yy"
    {
      tellvar = CMDBlock->getID((yyvsp[(1) - (1)].parsestr));
      if (tellvar) (yyval.pttname) = tellvar->get_type();
      else
      {
         tellerror("variable not defined in this scope", (yylsp[(1) - (1)]));
         (yyval.pttname) = telldata::tn_NULL;
      }
      delete [] (yyvsp[(1) - (1)].parsestr);
      indexed = false;
   }
    break;

  case 62:
#line 542 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname); indexed = false;}
    break;

  case 63:
#line 543 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname); indexed = true;}
    break;

  case 64:
#line 547 "tell_yacc.yy"
    {
      telldata::tell_var* v = CMDBlock->getID((yyvsp[(2) - (2)].parsestr), true);
      if (!v) {/* if this variableID doesn't exist already in the local scope*/
         /* add it to the local variable map */
         tellvar = CMDBlock->newTellvar((yyvsp[(1) - (2)].pttname), (yylsp[(1) - (2)]));
         CMDBlock->addID((yyvsp[(2) - (2)].parsestr),tellvar); 
      }
      else
         tellerror("variable already defined in this scope", (yylsp[(2) - (2)]));
      (yyval.pttname) = (yyvsp[(1) - (2)].pttname); delete [] (yyvsp[(2) - (2)].parsestr);indexed = false;
   }
    break;

  case 65:
#line 558 "tell_yacc.yy"
    {
      telldata::tell_var* v = CMDBlock->getID((yyvsp[(3) - (3)].parsestr), true);
      if (!v) {/* if this variableID doesn't exist already in the local scope*/
         /* add it to the local variable map */
         tellvar = CMDBlock->newTellvar((yyvsp[(2) - (3)].pttname), (yylsp[(2) - (3)]));
         CMDBlock->addconstID((yyvsp[(3) - (3)].parsestr),tellvar,false);
      }
      else
         tellerror("variable already defined in this scope", (yylsp[(2) - (3)]));
      (yyval.pttname) = (yyvsp[(2) - (3)].pttname); delete [] (yyvsp[(3) - (3)].parsestr);indexed = false;
   }
    break;

  case 66:
#line 569 "tell_yacc.yy"
    {
      telldata::tell_var* v = CMDBlock->getID((yyvsp[(3) - (3)].parsestr), true);
      if (!v) {/* if this variableID doesn't exist already in the local scope*/
         /* add it to the local variable map */
         tellvar = CMDBlock->newTellvar((yyvsp[(1) - (3)].pttname), (yylsp[(1) - (3)]));
         CMDBlock->addID((yyvsp[(3) - (3)].parsestr),tellvar);
      }
      else tellerror("variable already defined in this scope", (yylsp[(3) - (3)]));
      (yyval.pttname) = (yyvsp[(1) - (3)].pttname); delete [] (yyvsp[(3) - (3)].parsestr);indexed = false;
   }
    break;

  case 67:
#line 582 "tell_yacc.yy"
    {
      const telldata::tell_type* ftype =
            CMDBlock->getTypeByID((yyvsp[(1) - (2)].pttname) & ~telldata::tn_listmask);
      if (!tellstruct->addfield((yyvsp[(2) - (2)].parsestr), (yyvsp[(1) - (2)].pttname), ftype)) {
         tellerror("field with this name already defined in this strucutre", (yylsp[(2) - (2)]));
         (yyval.ptypedef) = false; // indicates that definition fails
      }
      else (yyval.ptypedef) = true;
      delete [] (yyvsp[(2) - (2)].parsestr);
   }
    break;

  case 68:
#line 595 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 69:
#line 596 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (2)].pttname) | telldata::tn_listmask;}
    break;

  case 70:
#line 601 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_void;}
    break;

  case 71:
#line 602 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_real;}
    break;

  case 72:
#line 603 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_int;}
    break;

  case 73:
#line 604 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_bool;}
    break;

  case 74:
#line 605 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_string;}
    break;

  case 75:
#line 606 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_layout;}
    break;

  case 76:
#line 607 "tell_yacc.yy"
    {
        const telldata::tell_type* ttype = CMDBlock->getTypeByName((yyvsp[(1) - (1)].parsestr));
        if (NULL == ttype)  {
           tellerror("Bad type specifier", (yylsp[(1) - (1)]));
           parsercmd::EOfile();
           YYABORT;

        }
        else (yyval.pttname) = ttype->ID();
        delete [] (yyvsp[(1) - (1)].parsestr);
      }
    break;

  case 77:
#line 621 "tell_yacc.yy"
    {
        tellstruct = CMDBlock->requesttypeID((yyvsp[(2) - (2)].parsestr));
        if (NULL == tellstruct) {
           tellerror("type with this name already defined", (yylsp[(1) - (2)]));
           delete [] (yyvsp[(2) - (2)].parsestr);
           parsercmd::EOfile();
           YYABORT;
        }
     }
    break;

  case 78:
#line 630 "tell_yacc.yy"
    {
        if ((yyvsp[(5) - (6)].ptypedef)) CMDBlock->addlocaltype((yyvsp[(2) - (6)].parsestr),tellstruct);
        else delete tellstruct;
        tellstruct = NULL;
        delete [] (yyvsp[(2) - (6)].parsestr);
     }
    break;

  case 79:
#line 639 "tell_yacc.yy"
    { (yyval.ptypedef) = (yyvsp[(1) - (1)].ptypedef);      }
    break;

  case 80:
#line 640 "tell_yacc.yy"
    { (yyval.ptypedef) = (yyvsp[(1) - (3)].ptypedef) && (yyvsp[(3) - (3)].ptypedef);}
    break;

  case 81:
#line 644 "tell_yacc.yy"
    {
      assert(NULL != tellvar);
      tellvar = tellvar->field_var((yyvsp[(2) - (2)].parsestr));
      if (tellvar) (yyval.pttname) = tellvar->get_type();
      else
      {
         tellerror("Bad field identifier", (yylsp[(2) - (2)]));
         (yyval.pttname) = telldata::tn_NULL;
      }
      delete [] (yyvsp[(2) - (2)].parsestr);
    }
    break;

  case 82:
#line 658 "tell_yacc.yy"
    {
      ListIndexCheck((yyvsp[(1) - (4)].pttname), (yylsp[(1) - (4)]), (yyvsp[(3) - (4)].pttname), (yylsp[(3) - (4)]));
      (yyval.pttname) = ((yyvsp[(1) - (4)].pttname) & (~telldata::tn_listmask));
    }
    break;

  case 83:
#line 665 "tell_yacc.yy"
    {
      if (ListIndexCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(4) - (5)].pttname), (yylsp[(4) - (5)])))
      {
         listadd_command = DEBUG_NEW parsercmd::cmdLISTADD(tellvar,true, true);
         (yyval.pttname) = (yyvsp[(1) - (5)].pttname); tell_lvalue = tellvar; lindexed = true;
      }
      else {
         (yyval.pttname) = telldata::tn_NULL; listadd_command = NULL;
      }
    }
    break;

  case 84:
#line 675 "tell_yacc.yy"
    {
      if ((yyvsp[(1) - (4)].pttname) & telldata::tn_listmask) {
         listadd_command = DEBUG_NEW parsercmd::cmdLISTADD(tellvar,true, false);
         (yyval.pttname) = (yyvsp[(1) - (4)].pttname); tell_lvalue = tellvar; lindexed = true;
      }
      else {
         tellerror("list expected",(yylsp[(1) - (4)]));
         (yyval.pttname) = telldata::tn_NULL; listadd_command = NULL;
      }
    }
    break;

  case 85:
#line 685 "tell_yacc.yy"
    {
      if (ListIndexCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(3) - (5)].pttname), (yylsp[(3) - (5)])))
      {
         listadd_command = DEBUG_NEW parsercmd::cmdLISTADD(tellvar,false, true);
         (yyval.pttname) = (yyvsp[(1) - (5)].pttname); tell_lvalue = tellvar; lindexed = true;
      }
      else {
         (yyval.pttname) = telldata::tn_NULL; listadd_command = NULL;
      }
    }
    break;

  case 86:
#line 695 "tell_yacc.yy"
    {
      if ((yyvsp[(1) - (4)].pttname) & telldata::tn_listmask) {
         listadd_command = DEBUG_NEW parsercmd::cmdLISTADD(tellvar,false, false);
         (yyval.pttname) = (yyvsp[(1) - (4)].pttname); tell_lvalue = tellvar; lindexed = true;
      }
      else {
         tellerror("list expected",(yylsp[(1) - (4)]));
         (yyval.pttname) = telldata::tn_NULL; listadd_command = NULL;
      }
    }
    break;

  case 87:
#line 708 "tell_yacc.yy"
    {
      if (ListIndexCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(4) - (5)].pttname), (yylsp[(4) - (5)])))
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSUB(tellvar,true, true));
      (yyval.pttname) = ((yyvsp[(1) - (5)].pttname) & (~telldata::tn_listmask));
    }
    break;

  case 88:
#line 713 "tell_yacc.yy"
    {
      if ((yyvsp[(1) - (4)].pttname) & telldata::tn_listmask)
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSUB(tellvar,true, false));
      else
         tellerror("list expected",(yylsp[(1) - (4)]));
      (yyval.pttname) = ((yyvsp[(1) - (4)].pttname) & (~telldata::tn_listmask));
    }
    break;

  case 89:
#line 720 "tell_yacc.yy"
    {
      if (ListIndexCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(3) - (5)].pttname), (yylsp[(3) - (5)])))
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSUB(tellvar,false, true));
      (yyval.pttname) = ((yyvsp[(1) - (5)].pttname) & (~telldata::tn_listmask));
    }
    break;

  case 90:
#line 725 "tell_yacc.yy"
    {
      if ((yyvsp[(1) - (4)].pttname) & telldata::tn_listmask)
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSUB(tellvar,false, false));
      else
         tellerror("list expected",(yylsp[(1) - (4)]));
      (yyval.pttname) = ((yyvsp[(1) - (4)].pttname) & (~telldata::tn_listmask));
    }
    break;

  case 91:
#line 735 "tell_yacc.yy"
    {
      if (ListSliceCheck((yyvsp[(1) - (6)].pttname), (yylsp[(1) - (6)]), (yyvsp[(5) - (6)].pttname), (yylsp[(5) - (6)]), (yyvsp[(3) - (6)].pttname), (yylsp[(3) - (6)])))
      {
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSLICE(tellvar, true, true));
         (yyval.pttname) = (yyvsp[(1) - (6)].pttname);
      }
      else
         (yyval.pttname) = telldata::tn_NULL;
    }
    break;

  case 92:
#line 744 "tell_yacc.yy"
    {
      if (ListSliceCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(3) - (5)].pttname), (yylsp[(3) - (5)])))
      {
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSLICE(tellvar, true, false));
         (yyval.pttname) = (yyvsp[(1) - (5)].pttname);
      }
      else
         (yyval.pttname) = telldata::tn_NULL;
    }
    break;

  case 93:
#line 753 "tell_yacc.yy"
    {
      if (ListSliceCheck((yyvsp[(1) - (6)].pttname), (yylsp[(1) - (6)]), (yyvsp[(3) - (6)].pttname), (yylsp[(3) - (6)]), (yyvsp[(5) - (6)].pttname), (yylsp[(5) - (6)])))
      {
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSLICE(tellvar, false, true));
         (yyval.pttname) = (yyvsp[(1) - (6)].pttname);
      }
      else
         (yyval.pttname) = telldata::tn_NULL;
    }
    break;

  case 94:
#line 762 "tell_yacc.yy"
    {
      if (ListSliceCheck((yyvsp[(1) - (5)].pttname), (yylsp[(1) - (5)]), (yyvsp[(4) - (5)].pttname), (yylsp[(4) - (5)])))
      {
         CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdLISTSLICE(tellvar, false, false));
         (yyval.pttname) = (yyvsp[(1) - (5)].pttname);
      }
      else
         (yyval.pttname) = telldata::tn_NULL;
    }
    break;

  case 95:
#line 774 "tell_yacc.yy"
    {
        argmap = DEBUG_NEW telldata::argumentQ;
        argmapstack.push(argmap);
   }
    break;

  case 96:
#line 778 "tell_yacc.yy"
    {
        /*Important note!. Here we will get a list of components that could be
          a tell list or some kind of tell struct or even tell list of tell struct.
          There is no way at this moment to determine the type of the input structure
          for (seems) obvious reasons. So - the type check and the eventual pushcmd
          are postponed untill we get the recepient - i.e. the lvalue or the
          function call. $$ is assigned to argumentID, that caries the whole argument
          queue listed in structure*/
        parsercmd::cmdSTRUCT* struct_command = DEBUG_NEW parsercmd::cmdSTRUCT();
        CMDBlock->pushcmd(struct_command);
        (yyval.parguments) = DEBUG_NEW telldata::argumentID(argmap, struct_command);
        //argQClear(argmap);
        argmapstack.pop();
        delete argmap;
        if (argmapstack.size() > 0) argmap = argmapstack.top();
        else argmap = NULL;
   }
    break;

  case 97:
#line 798 "tell_yacc.yy"
    {
      telldata::argumentID* op2 = (yyvsp[(2) - (2)].parguments);
      // the structure is without a type at this moment, so here we do the type checking
      if (parsercmd::StructTypeCheck((yyvsp[(1) - (2)].pttname), op2, (yylsp[(2) - (2)]))) {
         tellvar = CMDBlock->newTellvar((yyvsp[(1) - (2)].pttname), (yylsp[(1) - (2)]));
         parsercmd::Assign(tellvar, false, (yyvsp[(2) - (2)].parguments), (yylsp[(2) - (2)]));
         delete (yyvsp[(2) - (2)].parguments);
         (yyval.pttname) = (yyvsp[(1) - (2)].pttname);
      }
      else {
         tellerror("Type mismatch", (yylsp[(2) - (2)]));
         (yyval.pttname) = telldata::tn_NULL;
      }
   }
    break;

  case 98:
#line 817 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 99:
#line 818 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"||",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 100:
#line 819 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"|",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 101:
#line 823 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 102:
#line 824 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"&&",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 103:
#line 825 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname), "&",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 104:
#line 829 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 105:
#line 830 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"==",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 106:
#line 831 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"!=",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 107:
#line 835 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 108:
#line 836 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"<",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 109:
#line 837 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),">",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 110:
#line 838 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),"<=",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 111:
#line 839 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),">=",(yylsp[(1) - (3)]),(yylsp[(2) - (3)]));}
    break;

  case 112:
#line 843 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 113:
#line 844 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Plus((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]));}
    break;

  case 114:
#line 845 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Minus((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]));}
    break;

  case 115:
#line 846 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]),+1,+1);}
    break;

  case 116:
#line 847 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]),-1,+1);}
    break;

  case 117:
#line 848 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]),+1,-1);}
    break;

  case 118:
#line 849 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]),-1,-1);}
    break;

  case 119:
#line 853 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 120:
#line 854 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Multiply((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]));}
    break;

  case 121:
#line 855 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Divide((yyvsp[(1) - (3)].pttname),(yyvsp[(3) - (3)].pttname),(yylsp[(1) - (3)]),(yylsp[(3) - (3)]));}
    break;

  case 122:
#line 859 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 123:
#line 860 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::UMinus((yyvsp[(2) - (2)].pttname),(yylsp[(2) - (2)]));}
    break;

  case 124:
#line 861 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(2) - (2)].pttname), "!",(yylsp[(2) - (2)]));}
    break;

  case 125:
#line 862 "tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[(2) - (2)].pttname), "~",(yylsp[(2) - (2)]));}
    break;

  case 126:
#line 866 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_real;
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(DEBUG_NEW telldata::ttreal((yyvsp[(1) - (1)].real)), false, true));}
    break;

  case 127:
#line 868 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_int;
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(DEBUG_NEW telldata::ttint((yyvsp[(1) - (1)].integer)), false, true));}
    break;

  case 128:
#line 870 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_bool;
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(DEBUG_NEW telldata::ttbool(true), false, true));}
    break;

  case 129:
#line 872 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_bool;
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(DEBUG_NEW telldata::ttbool(false), false, true));}
    break;

  case 130:
#line 874 "tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_string;
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(DEBUG_NEW telldata::ttstring((yyvsp[(1) - (1)].parsestr)), false, true));
                                                                delete [] (yyvsp[(1) - (1)].parsestr);}
    break;

  case 131:
#line 877 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(tellvar, indexed));}
    break;

  case 132:
#line 879 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);
      CMDBlock->pushcmd(DEBUG_NEW parsercmd::cmdPUSH(tellvar, false, true));}
    break;

  case 133:
#line 881 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname); indexed = false;}
    break;

  case 134:
#line 882 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname); indexed = false;}
    break;

  case 135:
#line 883 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(2) - (3)].pttname);}
    break;

  case 136:
#line 884 "tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[(1) - (1)].pttname);}
    break;

  case 137:
#line 885 "tell_yacc.yy"
    {tellerror("Unexpected symbol", (yylsp[(1) - (1)]));}
    break;


/* Line 1267 of yacc.c.  */
#line 2827 "tell_yacc.cc"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the look-ahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 888 "tell_yacc.yy"

/*-------------------------------------------------------------------------*/
int yyerror (char *s) {  /* Called by yyparse on error */
   std::ostringstream ost;
   ost << "line " << telllloc.first_line << ": col " << telllloc.first_column
       << ": " << s;
   tell_log(console::MT_ERROR,ost.str());
   return 0;
}

void tellerror (std::string s, YYLTYPE loc) {
   if (cfd) cfd->incErrors();
   else     yynerrs++;
   std::ostringstream ost;
   ost << "line " << loc.first_line << ": col " << loc.first_column << ": ";
   if (loc.filename) {
      std::string fn = loc.filename;
      ost << "in file \"" << fn << "\" : ";
   }
   ost << s;
   tell_log(console::MT_ERROR,ost.str());
}

void tellerror (std::string s) {
   if (cfd) cfd->incErrors();
   else     yynerrs++;
   std::ostringstream ost;
   ost << "line " << telllloc.first_line << ": col " << telllloc.first_column << ": " << s;
   tell_log(console::MT_ERROR,ost.str());
}

